--Locale
local L_DODGE = " ".. _G["COMBAT_RATING_NAME3"]
local L_BOCK = " ".. _G["COMBAT_RATING_NAME5"]
local L_PARRY = " ".. _G["COMBAT_RATING_NAME4"]
local L_DEF = " ".. _G["COMBAT_RATING_NAME2"]
local L_SHB = " ".. _G["COMBAT_RATING_NAME8"]
local L_AVOI = " ".. _G["COMBAT_RATING_NAME9"]

--Objects Creation
local TaS = _G.CreateFrame("Frame", "StatBlock_TankStats")
local LDB = _G.LibStub("LibDataBroker-1.1")
TaS.Dodge = LDB:NewDataObject("Dodge", {text = "0%"..L_DODGE, value = "0%", suffix = L_DODGE})
TaS.Bock = LDB:NewDataObject("Block", {text = "0%"..L_BOCK, value = "0%", suffix = L_BOCK})
TaS.Parry = LDB:NewDataObject("Parry", {text = "0%"..L_PARRY, value = "0%", suffix = L_PARRY})
TaS.Def = LDB:NewDataObject("Defense", {text = "0"..L_DEF, value = "0", suffix = L_DEF})
TaS.ShB = LDB:NewDataObject("Shield Block", {text = "0"..L_SHB, value = "0", suffix = L_SHB})
TaS.Avoi = LDB:NewDataObject("Avoidance", {text = "0%"..L_SHB, value = "0%", suffix = L_AVOI})
LDB = nil

-- Upvalues
local format = _G.string.format
local GetCombatRating = _G.GetCombatRating
local GetCombatRatingBonus = _G.GetCombatRatingBonus
local UnitDefense = _G.UnitDefense
local GetBlockChance = _G.GetBlockChance
local GetDodgeChance = _G.GetDodgeChance
local GetParryChance = _G.GetParryChance
local GetShieldBlock = _G.GetShieldBlock
local player = "player"
local two_fp = "%.2f%%"
local single = "%d"
local two = "%.2f"

-- Combat Rating Constants
local CR_HIT_MELEE = 6
local CR_HASTE_MELEE = 18

--Events
TaS:RegisterEvent("UNIT_MODEL_CHANGED")
TaS:RegisterEvent("PLAYER_LEVEL_UP")
TaS:RegisterEvent("UNIT_AURA")
TaS:RegisterEvent("PLAYER_LOGIN")

--Calculations
TaS:SetScript("OnEvent", function(self, event, unit)
	--print(event, tostring(unit))
	if unit and unit ~= player then return end
	--print("pass")

	local dodge = format(two_fp, GetDodgeChance())
	self.Dodge.text = dodge..L_DODGE
	self.Dodge.value = dodge

	local bock = format(two_fp, GetBlockChance())
	self.Bock.text = bock..L_BOCK
	self.Bock.value = bock

	local parry = format(two_fp, GetParryChance())
	self.Parry.text = parry..L_PARRY
	self.Parry.value = parry

	local base, modifier = UnitDefense(player)
	local def = format(single, base+modifier)
	self.Def.text = def..L_DEF
	self.Def.value = def

	local shb = format(single, GetShieldBlock())
	self.ShB.text = shb..L_SHB
	self.ShB.value = shb
	
	local avoi = format(two_fp, GetBlockChance()+GetParryChance()+GetDodgeChance()+5+((base + modifier)-350)*0.04)
	self.Avoi.text = shb..L_AVOI
	self.Avoi.value = avoi	
end)
